/**

Ce programme est optimisé pour Processing dans sa version 1.5.1

Lycée Jean-Perrin

*/

//importation des librairies
import java.io.*;
import processing.opengl.*;
import jp.nyatla.nyar4psg.*;
import codeanticode.gsvideo.*;

//initialisation des variables
GSCapture cam;
MultiMarker nya_1;
MultiMarker nya_2;
MultiMarker nya_3;
MultiMarker nya_4;
/*MultiMarker nya_5;
/*MultiMarker nya_6;
MultiMarker nya_7;*/
int fps = 30;
GSMovieMaker  mm;

void setup() {
  
  // enregistrement
  //  frameRate(fps);
    mm = new GSMovieMaker (this, width, height, "drawing5.ogg", GSMovieMaker.THEORA, GSMovieMaker.MEDIUM, fps);
    mm.start();
    
 size(640,480,P3D);
 colorMode(RGB, 100);
 println(MultiMarker.VERSION);
 //déclaration des markers, on associe un marker à un pattern
 cam=new GSCapture(this,640,480);
 cam.start();
 
 //marker1
 nya_1=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_LEFT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_1.addARMarker("marker1.patt",80);

 //marker2
 nya_2=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_2.addARMarker("marker2.patt",80);

 //marker3
 nya_3=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_LEFT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_3.addARMarker("marker3.patt",80);

//marker4

 nya_4=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_4.addARMarker("marker4.patt",80);

/*//marker5   
 nya_5=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_5.addARMarker("marker5.patt",80);
 
/*  //marker6
 nya_6=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_6.addARMarker("marker6.patt",80);

 //marker7
 nya_7=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_7.addARMarker("marker7.patt",80); */

}

int c=0;
void drawgrid() //implemente un quadrillage
{
 pushMatrix();
 stroke(0);
 strokeWeight(2);
 line(0,0,0,100,0,0);
 popMatrix();
}

void draw() //implemente le dessin des objets liés aux markers
{
  c++;
  if (cam.available() !=true) {
   return;

 }

 //initialisation des markers à détecter
 cam.read();
 image(cam, 0, 0, 640, 480);
 nya_1.detect(cam);  //marker1
 nya_2.detect(cam);  //marker2
 nya_3.detect(cam);  //marker3
 nya_4.detect(cam);  //marker4
/* nya_5.detect(cam);  //marker5
/* nya_6.detect(cam);  //marker6
 nya_7.detect(cam);  //marker7
*/

 //f
 background(0);

 //initialisation d'une police de texte

 PFont w;
 w = createFont("Comic sans MS",65,true);
 nya_1.drawBackground(cam);
 nya_4.drawBackground(cam);

 //marker 1
 if((nya_1.isExistMarker(0))){
    nya_1.beginTransform(0);
    PImage sti2d1; //déclaration d'une image
    sti2d1 = loadImage("12.jpg");  //charger l'image "sti2d.jpg" et l'associe à la variable "sti2d"
    image(sti2d1,-180,-80,400,200);
    fill(0,0,255);
    drawgrid();
    rotate(0);
    scale(1,-1);
    nya_1.endTransform();

 }

 //marker 2

if((nya_2.isExistMarker(0))){
    nya_2.beginTransform(0);
    PImage bin; //déclaration d'une image
    bin = loadImage("notemusique.jpg");  //charger l'image "sti2d.jpg" et l'associe à la variable "sti2d"
    image(bin,-180,-80,200,100);
    fill(0,0,255);
    drawgrid();
    rotate(0);
    scale(1,-1);
    nya_2.endTransform();
}

//marker 3
    if((nya_3.isExistMarker(0))){
    nya_3.beginTransform(0);
    PImage geopolitiquenumerique; //déclaration d'une image
   geopolitiquenumerique = loadImage("geopolitique-numerique1.jpg");  //charger l'image "sti2d.jpg" et l'associe à la variable "sti2d"
    image(geopolitiquenumerique,-180,-80,400,200);
    fill(0,0,255);
    drawgrid();
    rotate(0);
    scale(1,-1);
    nya_3.endTransform();

 }

//marker 4

if((nya_4.isExistMarker(0))){
    nya_4.beginTransform(0);
    PImage er; //déclaration d'une image
    er = loadImage("er.jpg");  //charger l'image "sti2d.jpg" et l'associe à la variable "sti2d"
    image(er,-180,-80,400,200);
    fill(0,0,255);
    drawgrid();
    rotate(0);
    scale(1,-1);
    nya_4.endTransform();

 }

/*//marker5

 if((nya_5.isExistMarker(0))){
    nya_5.beginTransform(0);
    fill(0,255,255);
    drawgrid();
    translate(0,0,20);
    rotate((float)c/100);
    sphere(40);
    nya_5.endTransform();

 }

 /*

 //Marker 6
 if((nya_6.isExistMarker(0))){
    nya_6.beginTransform(0);
    fill(0,255,0);
    drawgrid();
    translate(0,0,20);
    rotate((float)c/100);
    box(40);
    nya_6.endTransform();

 }

 */ /*

 //marker 7

 if((nya_7.isExistMarker(0))){

    nya_7.beginTransform(0);

    fill(0,255,0);

    drawgrid();

    translate(0,0,20);

    rotate((float)c/100);

    box(40);

    nya_7.endTransform();

 } */

    //enregistrement
    loadPixels();
    mm.addFrame(pixels);
}

// permet l'arrêt du programme avec la touche "espace"
void keyPressed()
{
    if (key==' ')
    {
       mm.finish();
       exit();
    }
}

